%% Inspired by example 14 from Mueller (2014)

%% Include the BASIC EVENT CALCULUS THEORY
#include '../scasp_theory'.

% If a light is turned on, it will be on:
initiates(turn_on, on, T).

% If a light is turned on, whether it is red or green will be released
% from the commonsense law of inertia:
releases(turn_on, red, T).
releases(turn_on, green, T).

% If a light is turned off, it will not be on.
terminates(turn_off, on, T).

% After a light is turned on, it will emit red for up to two seconds
% and green after at least two seconds:
trajectory(on, T1, red, T2) :- T1 .<. T2, T2 .<. T1 + 1.
trajectory(on, T1, green, T2) :- T2 .>=. T1 + 1.

%initiallyN(on).

%% Actions
happens(turn_on, 2).
happens(turn_off, 4).
happens(turn_on, 5).

